//
//	$Date: 2003/08/15 05:51:22 $
//	$Revision: 1.4 $
//
#if SDK_VERSION >= 35
#include <PalmOS.h>
#else
#include <Pilot.h>
#include "NewTypes.h"
#endif

#include "palmwiki.h"
#include "pwprefs.h"
#include "id.h"

static MemPtr GetObjectPtr(UInt16 objectID)
{
	FormPtr frm;
	
	frm = FrmGetActiveForm();
	return (FrmGetObjectPtr(frm, FrmGetObjectIndex (frm, objectID)));
}

static void
CopyFieldTextToBuf(FieldPtr field, Char *buf, UInt16 lim)
{
	Char *s;
	UInt16 len;
	s = FldGetTextPtr(field);
	len = FldGetTextLength(field);
	if(len > lim) len = lim;
	StrNCopy(buf,s,len);
	buf[len] = '\0';
}

Boolean PrefsHandleEvent(EventPtr event)
{
	Boolean handled = false;
	FieldPtr field;
	ControlPtr ctl;
	WikiPref pref;
	
	FormPtr frm;

	switch(event->eType){
#ifdef APP
	case frmLoadEvent:
		frm = FrmInitForm(event->data.frmLoad.formID);
		ErrFatalDisplayIf(frm==NULL,"Null FormPtr");
	        FrmSetActiveForm(frm);
		FrmSetEventHandler(frm, PrefsHandleEvent);
		handled = true;
	        break;
#endif
	case ctlSelectEvent:
		switch (event->data.ctlSelect.controlID){
		case ID_BUTTON_OK:
			field = (FieldPtr)GetObjectPtr(ID_FIELD_LPAR);
			CopyFieldTextToBuf(field,pref.lpar,15);
			field = (FieldPtr)GetObjectPtr(ID_FIELD_RPAR);
			CopyFieldTextToBuf(field,pref.rpar,15);
			field = (FieldPtr)GetObjectPtr(ID_FIELD_MEMO);
			CopyFieldTextToBuf(field,pref.memo,4);
			field = (FieldPtr)GetObjectPtr(ID_FIELD_DATE);
			CopyFieldTextToBuf(field,pref.date,4);
			ctl = GetObjectPtr(ID_CHECKBOX_SINGLETAP);
			pref.singletap = (UInt16)CtlGetValue(ctl);
			ctl = GetObjectPtr(ID_CHECKBOX_USEWIKINAME);
			pref.usewikiname = (UInt16)CtlGetValue(ctl);
			pref.linkstackindex = 0;
			pref.linkstackmax = 0;

			SetWikiPreferences(&pref);
//			PrefSetAppPreferences(PWCREATOR,0,1,&pref,sizeof(WikiPref),true);
			// fall through
		case ID_BUTTON_CANCEL:
#ifdef HACK
			FrmGotoForm(9000); // Go back to HackMaster form
#endif
#ifdef APP
			{
				EventType evt;
				evt.eType = appStopEvent;
				EvtAddEventToQueue(&evt);
			}
#endif
			handled = true;
			break;
		default:
			break;
		}
		break;
  	case frmOpenEvent:
        	FrmDrawForm(FrmGetActiveForm());

		GsiSetLocation(143,15);
		GsiEnable(true);

		GetWikiPreferences(&pref,true);

		field = (FieldPtr)GetObjectPtr(ID_FIELD_LPAR);
		FldInsert(field,pref.lpar,StrLen(pref.lpar));
		field = (FieldPtr)GetObjectPtr(ID_FIELD_RPAR);
		FldInsert(field,pref.rpar,StrLen(pref.rpar));
		field = (FieldPtr)GetObjectPtr(ID_FIELD_MEMO);
		FldInsert(field,pref.memo,StrLen(pref.memo));
		field = (FieldPtr)GetObjectPtr(ID_FIELD_DATE);
		FldInsert(field,pref.date,StrLen(pref.date));
		ctl = GetObjectPtr(ID_CHECKBOX_SINGLETAP);
		CtlSetValue(ctl, (short)pref.singletap);
		ctl = GetObjectPtr(ID_CHECKBOX_USEWIKINAME);
		CtlSetValue(ctl, (short)pref.usewikiname);
		handled = true;
		break;
#ifdef APP
	case menuEvent:
		switch(event->data.menu.itemID){
		case ID_MENU_ABOUTHELP:
			frm = FrmInitForm(ID_HACK_ABOUT_FORM);
			ErrFatalDisplayIf(frm==0,"No about form");
			FrmSetActiveForm(frm);
			FrmDrawForm(frm);
			FrmDoDialog(frm);
			FrmReturnToForm(NULL);
			break;
		default:
			break;
		}
		handled = true;
		break;
#endif
	default:
		handled = false;
		break;
	}
	return handled;
}
